// C++ code
//Plant Light Level Detector Functional Code
//Code currently written in SECONDS for testing purposes!!
//Change to HOURS for true functionality!!
//Except for motor delays

#include <Servo.h>
Servo myservo;

//Motor 1 Pins

int AIN1 = 10;
int AIN2 = 11;
int PWMA1 = 9;

//Motor 2 Pins

int AIN3 = 13;
int AIN4 = 8;
int PWMA2 = 12;

//Servo Pin

int servopin = 7;

int servoloc;

//LED Pins

int red_LED = 6;
int yellow_LED = 5;
int blue_LED = 4;
int green_LED = 3;

//Light Value

int lightval[40];

int lightavg[4];

int lightsum;

// Array Multiplier

int z;

//Button

int button = 2;

int buttonval;


void setup()
{
  
  //Servo
  myservo.attach(servopin);
  
  //Wheel Motor 1  
  pinMode(AIN1, OUTPUT);
  pinMode(AIN2, OUTPUT);
  pinMode(PWMA1, OUTPUT);
  
  //Wheel Motor 2
  pinMode(AIN3, OUTPUT);
  pinMode(AIN4, OUTPUT);
  pinMode(PWMA2, OUTPUT);  
  
  //LED Pin Modes
  
  pinMode(red_LED, OUTPUT);
  pinMode(yellow_LED, OUTPUT);
  pinMode(blue_LED, OUTPUT); 
  pinMode(green_LED, OUTPUT);
  
  //Button Pinmode
  pinMode(button, INPUT_PULLUP);
  
}

void loop()
{
  buttonval = digitalRead(button);
  
  if (buttonval == LOW){
    
      digitalWrite(red_LED, LOW);
      digitalWrite(yellow_LED, LOW);
      digitalWrite(blue_LED, LOW);
      digitalWrite(green_LED, LOW);    
    
  //For Each of 4 Locations
  for (int i = 0; i <= 3; i++) {
    
    servoloc = 0;
    
    z = i*10; //Indexing value
    
    //For 10 different light values
    
    for (int j = 0; j<= 9; j++) {
      myservo.write(servoloc);
      delay(1000); // Delay between servo locations, if using 1 day per location on window sill, change to 86240000 (2.4 hours)
      
      lightval[j+z] = analogRead(A0); //Logs Light Data
      
      servoloc = servoloc+20; //Increments the Servo Position
    }
    
    
    if (i != 3){
      
    //Move between locations only if it isnt the last rotation
     
    //Wheel 
    
    digitalWrite(AIN3, HIGH);
    digitalWrite(AIN4, LOW);
    analogWrite(PWMA2, 130); //100- Speed
    
    delay(1000); //1 Second (Adjust based on length of windowsill)
    
    //Wheel
    
    digitalWrite(AIN3, HIGH);
    digitalWrite(AIN4, LOW);
    analogWrite(PWMA2, 0); //0 Speed
    }
    
  }
    for (int l = 0; l<=3; l++) {
      
      lightsum = 0;
      
      z = l*10;
      
      //Summation of each locations Light Values
      
      for (int p = 0; p<=9; p++) {
        
        lightsum = lightsum + lightval[p+z];
        
      }
      
      //Averaging for each location
      
      lightavg[l] = lightsum/10;
      
      
    }
    
    //If Position 1 has the most light
    
    if (lightavg[0] > lightavg[1] and lightavg[0] > lightavg[2] and lightavg[0] > lightavg[3]){
      digitalWrite(red_LED, HIGH);
      digitalWrite(yellow_LED, LOW);
      digitalWrite(blue_LED, LOW);
      digitalWrite(green_LED, LOW);
    }
    
    //If Position 2 has the most light

    if (lightavg[1] > lightavg[0] and lightavg[1] > lightavg[2] and lightavg[1] > lightavg[3]){
      digitalWrite(red_LED, LOW);
      digitalWrite(yellow_LED, HIGH);
      digitalWrite(blue_LED, LOW);
      digitalWrite(green_LED, LOW);
    } 
    
    //If Position 3 has the most light
    
    if (lightavg[2] > lightavg[0] and lightavg[2] > lightavg[1] and lightavg[2] > lightavg[3]){
      digitalWrite(red_LED, LOW);
      digitalWrite(yellow_LED, LOW);
      digitalWrite(blue_LED, HIGH);
      digitalWrite(green_LED, LOW);
    } 
    
    //If Position 4 has the most light
    
    if (lightavg[3] > lightavg[1] and lightavg[3] > lightavg[0] and lightavg[3] > lightavg[2]){
      digitalWrite(red_LED, LOW);
      digitalWrite(yellow_LED, LOW);
      digitalWrite(blue_LED, LOW);
      digitalWrite(green_LED, HIGH);
    }     

    //If any two values are the same

    if (lightavg[0] == lightavg[1] or lightavg[0] == lightavg[2] or lightavg[0] == lightavg[3] or lightavg[1] == lightavg[2] or lightavg[1] == lightavg[3]){
      
      digitalWrite(red_LED, HIGH);
      digitalWrite(yellow_LED, HIGH);
      digitalWrite(blue_LED, HIGH);
      digitalWrite(green_LED, HIGH);

    }

  
    
  }

}
  